/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   resample.h
 * Author: ilia
 *
 * Created on 5 октября 2017 г., 14:23
 */

#ifndef RESAMPLE_H
#define RESAMPLE_H

struct resampled_data
{
    short *samples;
    int samples_c;
};

enum
{
    SRATE_8000 = 0,
    SRATE_11025,
    SRATE_16000,
    SRATE_22050,
    SRATE_32000,
    SRATE_44100,
    SRATE_48000,
    SRATE_96000,
    SRATE_192000,
    
    SRATE_COUNT
};

enum
{
    RESAMPLED_ERROR_OK = 0,
    RESAMPLED_ERROR_MEMORY,
    RESAMPLED_ERROR_PROCESS,
    RESAMPLED_ERROR_FILE_READ,
    RESAMPLED_ERROR_FILE_FORMAT,
};

#ifdef __cplusplus
extern "C" {
#endif

typedef struct resampled_data *resampled_array_t;

int resampled_init(resampled_array_t *arr, const char *filename);

void resampled_free(resampled_array_t *arr);

struct resampled_data *resampled_get(resampled_array_t arr, unsigned int rate);

#ifdef __cplusplus
}
#endif

#endif /* RESAMPLE_H */
